package StackArray;

import java.util.ArrayList;
import java.util.Arrays;

/**
 * Expand the ArrayList implementation of stack here to use an Object[] array.  Still implement push, pop, and isEmpty.
 * Remember, you might need to resize the stack in the push method.
 *
 * @param <E>
 */
public class ObjectStack<E> {
    private Object[] elements;
    private ArrayList<E> stack = new ArrayList<>();
    private int top = 0;


    public ObjectStack() {
        elements = (E[]) new Object[stack.size()];
    }

    public boolean isEmpty() {
        if (stack.size() > 0) return false;
        return true;
    }

    public void push(E item) {
        stack.add(top++, item);
    }

    public E pop() throws Exception {
        E e = null;
        if (stack.size() == 0) throw new IndexOutOfBoundsException();
        for (int i = 0; i < stack.size(); i++) {
            e = stack.remove(stack.size() - 1);
        }
        return e;
    }
}
