package StackArrayList;

import java.util.ArrayList;

/**
 * Implement Stack<E> by adding the push, pop, and isEmpty functions.  It must pass the prewritten unit tests.
 * If you pop on an empty stack, throw an IndexOutOfBoundsException.
 */
public class Stack<E> {
    private ArrayList elements;
    private ArrayList<E> stack = new ArrayList<E>();
    private int top = 0;


    public Stack() {

    }

    public void push(E item) {
        stack.add(top++, item);
    }

    public Object pop() {
        E e = null;
        if (stack.size() == 0) throw new IndexOutOfBoundsException();
        for (int i = 0; i < stack.size(); i++) {
            e = stack.remove(stack.size() - 1);
        }
        return e;
    }


    public boolean isEmpty() {
        if (stack.size() > 0) return false;
        return true;
    }
}
