package MapFunc;

import java.util.ArrayList;
import java.util.function.Function;

/**
 * Create a function called `map` that takes an ArrayList and a `Function<T,R>` object,
 * and returns an ArrayList with all of the elements of the first after the function is applied to them.
 */
public class MapFunc {
    public static <E,T> ArrayList<E> map(ArrayList<T> elements, Function<T,E> function){
               ArrayList<E> arrayList =  new ArrayList<>();
                for (int i = 0; i < elements.size() ; i++) {
                        T t = elements.get(i);
                       arrayList.add(function.apply(t));
                    }
                return arrayList;
            }

}
