package Pair;

import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;

/**
 * In here you must make firstLast, which will return a pair of the first element in the array list and the last
 * element in the arraylist.
 * You must also make a min method that returns the smallest item in the array list
 * A max method that returns the largest item in the arraylist
 * And a minmax method that returns a pair containing the largest and smallest items from the array list
 */
public class Arrays {

    public static <E extends Comparable> Pair firstLast(ArrayList<E> as) {
        E min = as.get(0);
        E max = as.get(as.size()-1);

        System.out.println(min);
        System.out.println(max);

        return new Pair(min, max);
    }

    public static <E extends Comparable> Pair minMax(ArrayList<E> al) {
        E min = al.get(0);
        E max = al.get(1);

        for (E e: al) {
            if(e.compareTo(min) < 0){
                min = e;
            }
            if(e.compareTo(max) > 0){
                max = e;
            }
        }

        return new Pair(max, min);
    }




    public static <E extends Comparable> E min(ArrayList<E> al) {
        return (E) minMax(al).min();
    }

    public static  <E extends Comparable> E  max(ArrayList<E> al) {
        return (E) minMax(al).max();
    }

}